## qubes-gui-agent 4.0.35

=== Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Joanna Rutkowska <joanna@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

RPMS_DIR=rpm/
VERSION := $(shell cat version)

DIST_DOM0 ?= fc13

LIBDIR ?= /usr/lib64
USRLIBDIR ?= /usr/lib
SYSLIBDIR ?= /lib
DATADIR ?= /usr/share
PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)

help:
	@echo "Qubes GUI main Makefile:" ;\
	    echo "make rpms                 <--- make all rpms and sign them";\
	    echo "make rpms-dom0            <--- create binary rpms for dom0"; \
	    echo "make rpms-vm              <--- create binary rpms for appvm"; \
	    echo; \
	    echo "make clean                <--- clean all the binary files";\
	    echo "make update-repo-current  <-- copy newly generated rpms to qubes yum repo";\
	    echo "make update-repo-current-testing <-- same, but for -current-testing repo";\
	    echo "make update-repo-unstable <-- same, but to -testing repo";\
	    echo "make update-repo-installer -- copy dom0 rpms to installer repo"
	    @exit 0;

appvm: gui-agent/qubes-gui gui-common/qubes-gui-runuser \
	xf86-input-mfndev/src/.libs/qubes_drv.so \
	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so

gui-agent/qubes-gui:
	(cd gui-agent; $(MAKE))

gui-common/qubes-gui-runuser:
	(cd gui-common; $(MAKE))

xf86-input-mfndev/src/.libs/qubes_drv.so:
	(cd xf86-input-mfndev && ./autogen.sh && ./configure && make LDFLAGS=-lu2mfn)

xf86-video-dummy/src/.libs/dummyqbs_drv.so:
	(cd xf86-video-dummy && ./autogen.sh && make)

pulse/module-vchan-sink.so:
	rm -f pulse/pulsecore
	ln -s pulsecore-$(PA_VER_FULL) pulse/pulsecore
	$(MAKE) -C pulse module-vchan-sink.so

rpms: rpms-dom0 rpms-vm
	rpm --addsign rpm/x86_64/*$(VERSION)*.rpm
	(if [ -d rpm/i686 ] ; then rpm --addsign rpm/i686/*$(VERSION)*.rpm; fi)

rpms-vm:
	rpmbuild --define "_rpmdir rpm/" -bb rpm_spec/gui-vm.spec

tar:
	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

clean:
	(cd common && $(MAKE) clean)
	(cd gui-agent && $(MAKE) clean)
	(cd gui-common && $(MAKE) clean)
	$(MAKE) -C pulse clean
	(cd xf86-input-mfndev; if [ -e Makefile ] ; then \
		$(MAKE) distclean; fi; ./bootstrap --clean || echo )
	rm -rf debian/changelog.*
	rm -rf pkgs


install: install-rh-agent install-pulseaudio

install-rh-agent: appvm install-common
	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
		$(DESTDIR)/etc/sysconfig/desktop
	install -D appvm-scripts/etc/sysconfig/modules/qubes-u2mfn.modules \
		$(DESTDIR)/etc/sysconfig/modules/qubes-u2mfn.modules
	install -m 0755 -D appvm-scripts/etc/X11/xinit/xinitrc.d/qubes-keymap.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-keymap.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh

install-xfce:
	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50-xfce-desktop.sh \
		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50-xfce-desktop.sh

install-debian: appvm install-common install-pulseaudio
	install -d $(DESTDIR)/etc/X11/Xsession.d
	install -m 0755 appvm-scripts/etc/X11/xinit/xinitrc.d/qubes-keymap.sh \
		$(DESTDIR)/etc/X11/Xsession.d/90qubes-keymap
	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
	install -d $(DESTDIR)/etc/xdg
	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg
	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service

install-pulseaudio:
	install -D pulse/start-pulseaudio-with-vchan \
		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
	install -m 0644 -D pulse/qubes-default.pa \
		$(DESTDIR)/etc/pulse/qubes-default.pa
ifneq ($(shell lsb_release -is), Ubuntu)
	install -D pulse/module-vchan-sink.so \
		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
else
	install -D pulse/module-vchan-sink.so \
		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_FULL)/modules/module-vchan-sink.so
endif
	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-pulseaudio.desktop

install-common:
	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
	install -D gui-common/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
	install -D appvm-scripts/usrbin/qubes-session \
		$(DESTDIR)/usr/bin/qubes-session
	install -D appvm-scripts/usrbin/qubes-run-xorg \
		$(DESTDIR)/usr/bin/qubes-run-xorg
	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
		$(DESTDIR)/usr/bin/qubes-set-monitor-layout
	install -D xf86-input-mfndev/src/.libs/qubes_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/qubes_drv.so
	install -D xf86-video-dummy/src/.libs/dummyqbs_drv.so \
		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/dummyqbs_drv.so
	install -m 0644 -D appvm-scripts/etc/X11/xorg-qubes.conf.template \
		$(DESTDIR)/etc/X11/xorg-qubes.conf.template
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.sh \
		$(DESTDIR)/etc/profile.d/qubes-gui.sh
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-gui.csh \
		$(DESTDIR)/etc/profile.d/qubes-gui.csh
	install -m 0644 -D appvm-scripts/etc/profile.d/qubes-session.sh \
		$(DESTDIR)/etc/profile.d/qubes-session.sh
	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-session.conf \
		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-session.conf
	install -m 0644 -D appvm-scripts/etc/securitylimits.d/90-qubes-gui.conf \
		$(DESTDIR)/etc/security/limits.d/90-qubes-gui.conf
ifneq ($(shell lsb_release -is), Ubuntu)
	install -m 0644 -D appvm-scripts/etc/xdg/Trolltech.conf \
		$(DESTDIR)/etc/xdg/Trolltech.conf
endif
	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
	install -d $(DESTDIR)/etc/qubes-rpc
	ln -s ../../usr/bin/qubes-set-monitor-layout \
		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
	install -D window-icon-updater/icon-sender \
		$(DESTDIR)/usr/lib/qubes/icon-sender
	install -m 0644 -D window-icon-updater/qubes-icon-sender.desktop \
		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
	install -D -m 0644 appvm-scripts/usr/lib/modules-load.d/qubes-gui.conf \
		$(DESTDIR)/usr/lib/modules-load.d/qubes-gui.conf
	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
ifeq ($(shell lsb_release -is), Debian)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Ubuntu)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else ifeq ($(shell lsb_release -is), Arch)
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.archlinux \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
else
	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent \
		$(DESTDIR)/etc/pam.d/qubes-gui-agent
endif
	install -d $(DESTDIR)/var/log/qubes

=== gui-agent/Makefile ===
#
# The Qubes OS Project, http://www.qubes-os.org
#
# Copyright (C) 2010  Rafal Wojtczuk  <rafal@invisiblethingslab.com>
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#
#

CC ?= gcc
CFLAGS += -I../include/ `pkg-config --cflags vchan-$(BACKEND_VMM)` -g -Wall -Wextra -Werror -pie -fPIC
OBJS = vmside.o \
	../gui-common/txrx-vchan.o ../gui-common/error.o ../common/list.o ../gui-common/encoding.o
LIBS = -lX11 -lXdamage -lXcomposite `pkg-config --libs vchan-$(BACKEND_VMM)` -lqubesdb


all: qubes-gui
qubes-gui: $(OBJS)
	$(CC) $(LDFLAGS) -pie -g -o qubes-gui $(OBJS) \
		$(LIBS)
clean:
	rm -f qubes-gui *.o *~

=== debian/changelog ===
qubes-gui-agent (4.0.35-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Wed, 27 Jan 2021 06:26:25 +0100

qubes-gui-agent (4.0.35-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Add pulseaudio-14.1 headers
  * Add pulseaudio 14.2 headers

  [ unman ]
  * Fix pulseaudio in Ubuntu templates

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 27 Jan 2021 06:26:25 +0100

## qubes-gui-agent 4.0.36

=== debian/changelog ===
qubes-gui-agent (4.0.36-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Mon, 15 Mar 2021 23:23:22 +0100

qubes-gui-agent (4.0.36-1) unstable; urgency=medium

  [ Rusty Bird ]
  * vmside: fix strncat() buffer overflow in getwmname_tochar()

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 15 Mar 2021 23:23:22 +0100

=== debian/control ===
Source: qubes-gui-agent
Section: admin
Priority: extra
Maintainer: Davíð Steinn Geirsson <david@dsg.is>
Build-Depends:
    debhelper,
    libpam0g-dev,
    libpulse-dev,
    libtool,
    automake,
    xserver-xorg-dev,
    xutils-dev,
    libvchan-xen-dev,
    libx11-dev,
    libxcomposite-dev,
    libxdamage-dev,
    x11proto-xf86dga-dev,
    libxt-dev,
    lsb-release,
    quilt,
    qubes-gui-common (>= 3.2.0),
    qubesdb-dev,
    libltdl-dev
Standards-Version: 4.4.0.1
Homepage: http://www.qubes-os.org/
#Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git
#Vcs-Browser: http://git.debian.org/?p=collab-maint/qubes-gui-agent.git;a=summary

Package: qubes-gui-agent
Architecture: any
Depends:
    xserver-xorg-core,
    xinit,
    x11-xserver-utils,
    qubes-core-agent (>= 3.0.14),
    qubesdb-vm,
    libxdamage1,
    libxcomposite1,
    libxt6,
    libx11-6,
    python3,
    python3-xcffib,
    xserver-xorg-video-dummyqbs (= ${binary:Version}),
    xserver-xorg-input-qubes (= ${binary:Version}),
    ${shlibs:Depends},
    ${misc:Depends}
Recommends: qt4-qtconfig, pulseaudio-qubes
Provides: x-display-manager
Description: Makes X11 windows available to qubes dom0
 The Qubes GUI agent allows the forwarding of running app windows to the
 qubes dom0. It also includes various extras such as copy/paste support.

Package: xserver-xorg-video-dummyqbs
Architecture: any
Depends:
 ${xviddriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 ${xviddriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: Dummy X video driver for qubes-gui-agent
 Dummy X video driver for Qubes VM, with XRandr support.

Package: xserver-xorg-input-qubes
Architecture: any
Depends:
 ${xinpdriver:Depends},
 ${shlibs:Depends},
 ${misc:Depends}
Provides:
 ${xinpdriver:Provides}
Replaces: qubes-gui-agent (<< 3.2.11-1)
Breaks: qubes-gui-agent (<< 3.2.11-1)
Description: X input driver for injecting events from qubes-gui-agent
 This driver inject input events delivered through qubes-gui-agent.
 Additionally it helps retrieving composition buffers of windows.

Package: pulseaudio-qubes
Architecture: any
Depends:
    pulseaudio,
    libpulse0,
    ${shlibs:Depends},
    ${pulse:Depends},
    ${misc:Depends}
Replaces: qubes-gui-agent (<< 4.0.0-1)
Breaks: qubes-gui-agent (<< 4.0.0-1)
Description: Audio support for Qubes VM
 Pulseaudio module to enable sound support in Qubes VM

## qubes-gui-agent 4.0.37

=== debian/changelog ===
qubes-gui-agent (4.0.37-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 10 Jul 2021 04:04:18 +0200

qubes-gui-agent (4.0.37-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * spec: ensure R for few x11 tools

  [ Marek Marczykowski-Górecki ]
  * rpm: add xrandr dependency

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 10 Jul 2021 04:04:18 +0200

## qubes-gui-agent 4.0.38

=== debian/changelog ===
qubes-gui-agent (4.0.38-1+deb9u1) stretch; urgency=medium

  * Build for stretch

 -- Builder <user@localhost>  Tue, 24 Aug 2021 04:17:10 +0200

qubes-gui-agent (4.0.38-1) unstable; urgency=medium

  [ fepitre-bot ]
  * Add pulseaudio-15.0 headers

  [ Marek Marczykowski-Górecki ]
  * pulse: set module version to the PA version

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Tue, 24 Aug 2021 04:17:10 +0200

## qubes-gui-agent 4.1.0

=== Makefile ===
--- 
+++ 
@@ -28,8 +28,7 @@
 USRLIBDIR ?= /usr/lib
 SYSLIBDIR ?= /lib
 DATADIR ?= /usr/share
-PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
-PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)
+PA_VER ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -46,7 +45,8 @@
 
 appvm: gui-agent/qubes-gui gui-common/qubes-gui-runuser \
 	xf86-input-mfndev/src/.libs/qubes_drv.so \
-	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so
+	xf86-video-dummy/src/.libs/dummyqbs_drv.so pulse/module-vchan-sink.so \
+	xf86-qubes-common/libxf86-qubes-common.so
 
 gui-agent/qubes-gui:
 	(cd gui-agent; $(MAKE))
@@ -54,16 +54,19 @@
 gui-common/qubes-gui-runuser:
 	(cd gui-common; $(MAKE))
 
-xf86-input-mfndev/src/.libs/qubes_drv.so:
-	(cd xf86-input-mfndev && ./autogen.sh && ./configure && make LDFLAGS=-lu2mfn)
+xf86-input-mfndev/src/.libs/qubes_drv.so: xf86-qubes-common/libxf86-qubes-common.so
+	(cd xf86-input-mfndev && ./autogen.sh && ./configure && make)
 
-xf86-video-dummy/src/.libs/dummyqbs_drv.so:
+xf86-video-dummy/src/.libs/dummyqbs_drv.so: xf86-qubes-common/libxf86-qubes-common.so
 	(cd xf86-video-dummy && ./autogen.sh && make)
 
 pulse/module-vchan-sink.so:
 	rm -f pulse/pulsecore
-	ln -s pulsecore-$(PA_VER_FULL) pulse/pulsecore
+	ln -s pulsecore-$(PA_VER) pulse/pulsecore
 	$(MAKE) -C pulse module-vchan-sink.so
+
+xf86-qubes-common/libxf86-qubes-common.so:
+	$(MAKE) -C xf86-qubes-common libxf86-qubes-common.so
 
 rpms: rpms-dom0 rpms-vm
 	rpm --addsign rpm/x86_64/*$(VERSION)*.rpm
@@ -80,21 +83,20 @@
 	(cd gui-agent && $(MAKE) clean)
 	(cd gui-common && $(MAKE) clean)
 	$(MAKE) -C pulse clean
+	$(MAKE) -C xf86-qubes-common clean
 	(cd xf86-input-mfndev; if [ -e Makefile ] ; then \
 		$(MAKE) distclean; fi; ./bootstrap --clean || echo )
-	rm -rf debian/changelog.*
-	rm -rf pkgs
 
 
 install: install-rh-agent install-pulseaudio
 
 install-rh-agent: appvm install-common
+	install -D appvm-scripts/etc/init.d/qubes-gui-agent \
+		$(DESTDIR)/etc/init.d/qubes-gui-agent
 	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
 		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
 	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
 		$(DESTDIR)/etc/sysconfig/desktop
-	install -D appvm-scripts/etc/sysconfig/modules/qubes-u2mfn.modules \
-		$(DESTDIR)/etc/sysconfig/modules/qubes-u2mfn.modules
 	install -m 0755 -D appvm-scripts/etc/X11/xinit/xinitrc.d/qubes-keymap.sh \
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-keymap.sh
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
@@ -121,13 +123,8 @@
 		$(DESTDIR)/usr/bin/start-pulseaudio-with-vchan
 	install -m 0644 -D pulse/qubes-default.pa \
 		$(DESTDIR)/etc/pulse/qubes-default.pa
-ifneq ($(shell lsb_release -is), Ubuntu)
 	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
-else
-	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_FULL)/modules/module-vchan-sink.so
-endif
+		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER)/modules/module-vchan-sink.so
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \
@@ -144,6 +141,8 @@
 		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
 	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
 		$(DESTDIR)/usr/bin/qubes-set-monitor-layout
+	install -D xf86-qubes-common/libxf86-qubes-common.so \
+		$(DESTDIR)$(LIBDIR)/libxf86-qubes-common.so
 	install -D xf86-input-mfndev/src/.libs/qubes_drv.so \
 		$(DESTDIR)$(LIBDIR)/xorg/modules/drivers/qubes_drv.so
 	install -D xf86-video-dummy/src/.libs/dummyqbs_drv.so \
@@ -166,8 +165,7 @@
 endif
 	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
 		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
-	install -d $(DESTDIR)/etc/qubes-rpc
-	ln -s ../../usr/bin/qubes-set-monitor-layout \
+	install -m 0644 -D appvm-scripts/etc/qubes-rpc/qubes.SetMonitorLayout \
 		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
 	install -D window-icon-updater/icon-sender \
 		$(DESTDIR)/usr/lib/qubes/icon-sender
@@ -175,8 +173,6 @@
 		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
 	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
 		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
-	install -D -m 0644 appvm-scripts/usr/lib/modules-load.d/qubes-gui.conf \
-		$(DESTDIR)/usr/lib/modules-load.d/qubes-gui.conf
 	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
 		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
 ifeq ($(shell lsb_release -is), Debian)

=== debian/changelog ===
qubes-gui-agent (4.1.0-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Sat, 09 Mar 2019 05:37:31 +0100

qubes-gui-agent (4.1.0-1) unstable; urgency=medium

  [ Simon Gaiser ]
  * Adapt to new gui protocol version using grant refs

  [ Marek Marczykowski-Górecki ]
  * vmside: handle memory allocation error
  * Use CFLAGS/LDFLAGS set by rpm
  * rpm/deb: bump required qubes-gui-common-devel version
  * xf86-video-dummy: fix compiler warning
  * xf86-video-dummy: fix FBBase release
  * Increase gntalloc limit

  [ Your Name ]
  * CLIPBOARD_DATA: send window id, and ignore window id in incoming
    pastes

  [ Marek Marczykowski-Górecki ]
  * travis: update to R4.1
  * rpm,deb: add xen devel to build requirements

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 09 Mar 2019 05:37:31 +0100

## qubes-gui-agent 4.1.1

=== debian/changelog ===
qubes-gui-agent (4.1.1-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Sat, 08 Jun 2019 12:35:03 +0200

qubes-gui-agent (4.1.1-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * video-dummy: fix off by one error in memory size check
  * Convert qubes-change-keyboard-layout to python3
  * travis: add fc30, switch to xenial

  [ Frédéric Pierret (fepitre) ]
  * Init script qubes-gui-agent is not needed anymore
  * spec: ensure we remove empty /etc/inid.d folder
  * spec: better use rmdir and check if exist for /etc/init.d

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 08 Jun 2019 12:35:03 +0200

## qubes-gui-agent 4.1.2

=== debian/changelog ===
qubes-gui-agent (4.1.2-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Mon, 01 Jul 2019 02:29:38 +0200

qubes-gui-agent (4.1.2-1) wheezy; urgency=medium

  [ Laurent ]
  * Update PKGBUILD

  [ xaki23 ]
  * add modargs for target domid and sink/source descr strings

  [ Marek Marczykowski-Górecki ]
  * Build package for dom0 too
  * debian: add Build-Depends: lsb-release

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 01 Jul 2019 02:29:38 +0200

## qubes-gui-agent 4.1.3

=== Makefile ===
--- 
+++ 
@@ -91,8 +91,6 @@
 install: install-rh-agent install-pulseaudio
 
 install-rh-agent: appvm install-common
-	install -D appvm-scripts/etc/init.d/qubes-gui-agent \
-		$(DESTDIR)/etc/init.d/qubes-gui-agent
 	install -m 0644 -D appvm-scripts/qubes-gui-agent.service \
 		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
 	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \

=== debian/changelog ===
qubes-gui-agent (4.1.3-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Fri, 06 Sep 2019 05:32:10 +0200

qubes-gui-agent (4.1.3-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * Add pulseaudio-12.99.2 symlinked headers
  * spec: handle newer pulseaudio for Fedora 31+

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 06 Sep 2019 05:32:10 +0200

## qubes-gui-agent 4.1.4

=== Makefile ===
--- 
+++ 
@@ -135,6 +135,8 @@
 		$(DESTDIR)/usr/bin/qubes-session
 	install -D appvm-scripts/usrbin/qubes-run-xorg \
 		$(DESTDIR)/usr/bin/qubes-run-xorg
+	install -D appvm-scripts/usrbin/qubes-run-xephyr \
+		$(DESTDIR)/usr/bin/qubes-run-xephyr
 	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
 		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
 	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
@@ -157,6 +159,8 @@
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-session.conf
 	install -m 0644 -D appvm-scripts/etc/securitylimits.d/90-qubes-gui.conf \
 		$(DESTDIR)/etc/security/limits.d/90-qubes-gui.conf
+	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50-guivm-windows-prefix.sh \
+		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50-guivm-windows-prefix.sh
 ifneq ($(shell lsb_release -is), Ubuntu)
 	install -m 0644 -D appvm-scripts/etc/xdg/Trolltech.conf \
 		$(DESTDIR)/etc/xdg/Trolltech.conf
@@ -169,6 +173,8 @@
 		$(DESTDIR)/usr/lib/qubes/icon-sender
 	install -m 0644 -D window-icon-updater/qubes-icon-sender.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
+	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-qrexec-fork-server.desktop \
+		$(DESTDIR)/etc/xdg/autostart/qubes-qrexec-fork-server.desktop
 	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
 		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
 	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \

=== gui-agent/Makefile ===
--- 
+++ 
@@ -22,7 +22,7 @@
 CC ?= gcc
 CFLAGS += -I../include/ `pkg-config --cflags vchan-$(BACKEND_VMM)` -g -Wall -Wextra -Werror -pie -fPIC
 OBJS = vmside.o \
-	../gui-common/txrx-vchan.o ../gui-common/error.o ../common/list.o ../gui-common/encoding.o
+	../gui-common/txrx-vchan.o ../gui-common/error.o ../common/list.o 
 LIBS = -lX11 -lXdamage -lXcomposite `pkg-config --libs vchan-$(BACKEND_VMM)` -lqubesdb

=== gui-common/Makefile ===
CC ?= gcc
CFLAGS += -g -Wall -Wextra -Werror -pie -fPIC
LDLIBS = -lpam

all: qubes-gui-runuser

qubes-gui-runuser: qubes-gui-runuser.c

clean:
	rm -f *.o

=== pulse/Makefile ===
CC=gcc
CFLAGS=-Wall -Wextra -Werror -O2
VCHANLIBS=`pkg-config --libs vchan-$(BACKEND_VMM)`
VCHANCFLAGS=`pkg-config --cflags vchan-$(BACKEND_VMM)`
GLIBCFLAGS=`pkg-config --cflags glib-2.0` `pkg-config --cflags dbus-glib-1`
GLIBLIBS=`pkg-config --libs glib-2.0` `pkg-config --libs dbus-glib-1` `pkg-config --libs gthread-2.0`
all: module-vchan-sink.so
module-vchan-sink.so: module-vchan-sink.o
	$(CC) -shared -o module-vchan-sink.so module-vchan-sink.o \
		$(VCHANLIBS)
module-vchan-sink.o: module-vchan-sink.c
	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -I.
clean:
	rm -f *.so *.o *~

=== xf86-qubes-common/Makefile ===
XORG_SERVER_CFLAGS=$(shell pkg-config --cflags xorg-server)

all: libxf86-qubes-common.so

libxf86-qubes-common.so: xf86-qubes-common.c include/xf86-qubes-common.h
	gcc -Wall -shared -fPIC -DPIC $(XORG_SERVER_CFLAGS) $(CFLAGS) $(LDFLAGS) \
		-o libxf86-qubes-common.so xf86-qubes-common.c

clean:
	rm -f *.so

=== debian/changelog ===
qubes-gui-agent (4.1.4-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Wed, 13 Nov 2019 06:13:10 +0100

qubes-gui-agent (4.1.4-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * Fix qubes-change-keyboard-layout after migrating to python3

  [ Neowutran ]
  * add pulseaudio 13.0 headers

  [ Marek Marczykowski-Górecki ]
  * archlinux: do not force python2 anymore
  * rpm: update pulseaudio version

  [ Neowutran ]
  * Archlinux: Allow any pulseaudio version between 13.0 and 14.0 for
    qubes-vm-pulseaudio

  [ Frédéric Pierret (fepitre) ]
  * travis: switch to bionic
  * qubes-keymap: handle input of keyboard layout
  * qubes-keymap: handle variant in qubesdb
  * qubes-run-xorg: make ShellChek happy
  * Improve GuiVM session workflow
  * qubes-run-xephyr: update options
  * qubes-run-xorg: improvements from Marek's investigations for session
    reseting
  * qubes-keymap: handle options in qubesdb
  * xinitrc.d: add set of _QUBES_VMNAME atom

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Wed, 13 Nov 2019 06:13:10 +0100

## qubes-gui-agent 4.1.5

=== Makefile ===
--- 
+++ 
@@ -131,6 +131,9 @@
 install-common:
 	install -D gui-agent/qubes-gui $(DESTDIR)/usr/bin/qubes-gui
 	install -D gui-common/qubes-gui-runuser $(DESTDIR)/usr/bin/qubes-gui-runuser
+	install -d $(DESTDIR)/etc/qubes/post-install.d
+	install -m 0755 appvm-scripts/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh \
+                $(DESTDIR)/etc/qubes/post-install.d/20-qubes-guivm-gui-agent.sh
 	install -D appvm-scripts/usrbin/qubes-session \
 		$(DESTDIR)/usr/bin/qubes-session
 	install -D appvm-scripts/usrbin/qubes-run-xorg \

=== debian/changelog ===
qubes-gui-agent (4.1.5-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 30 Nov 2019 05:14:16 +0100

qubes-gui-agent (4.1.5-1) unstable; urgency=medium

  [ Frédéric Pierret (fepitre) ]
  * qvm-features-request: add guivm-gui-agent
  * qubes-session: fix too late loginctl activate
  * vmside: fix vchan reconnect to domid 0
  * module-vchan-sink: read domid from qubesdb
  * module-vchan-sink: convert tabs to spaces
  * module-vchan-sink: log for domid used

  [ Otto Sabart ]
  * archlinux: qubes-vm-gui: update PKGBUILD

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 30 Nov 2019 05:14:16 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: extra
 Maintainer: Davíð Steinn Geirsson <david@dsg.is>
 Build-Depends:
-    debhelper,
     libpam0g-dev,
     libpulse-dev,
     libtool,
@@ -16,12 +15,15 @@
     libxdamage-dev,
     x11proto-xf86dga-dev,
     libxt-dev,
+    libxen-dev,
     lsb-release,
     quilt,
-    qubes-gui-common (>= 3.2.0),
+    debhelper (>= 8.0.0),
+    qubes-gui-common (>= 4.1.0),
     qubesdb-dev,
+    dh-systemd (>= 1.5),
     libltdl-dev
-Standards-Version: 4.4.0.1
+Standards-Version: 3.9.8
 Homepage: http://www.qubes-os.org/
 #Vcs-Git: git://git.debian.org/collab-maint/qubes-gui-agent.git
 #Vcs-Browser: http://git.debian.org/?p=collab-maint/qubes-gui-agent.git;a=summary
@@ -50,12 +52,21 @@
  The Qubes GUI agent allows the forwarding of running app windows to the
  qubes dom0. It also includes various extras such as copy/paste support.
 
+Package: xserver-xorg-qubes-common
+Architecture: any
+Depends:
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: Common functions for qubes xserver driver
+ Shared library which contains common functions of the Qubes xserver drivers.
+
 Package: xserver-xorg-video-dummyqbs
 Architecture: any
 Depends:
  ${xviddriver:Depends},
  ${shlibs:Depends},
- ${misc:Depends}
+ ${misc:Depends},
+ xserver-xorg-qubes-common (= ${binary:Version})
 Provides:
  ${xviddriver:Provides}
 Replaces: qubes-gui-agent (<< 3.2.11-1)
@@ -68,7 +79,8 @@
 Depends:
  ${xinpdriver:Depends},
  ${shlibs:Depends},
- ${misc:Depends}
+ ${misc:Depends},
+ xserver-xorg-qubes-common (= ${binary:Version})
 Provides:
  ${xinpdriver:Provides}
 Replaces: qubes-gui-agent (<< 3.2.11-1)

## qubes-gui-agent 4.1.6

=== Makefile ===
--- 
+++ 
@@ -170,7 +170,8 @@
 endif
 	install -m 0644 -D appvm-scripts/qubes-gui-vm.gschema.override \
 		$(DESTDIR)$(DATADIR)/glib-2.0/schemas/20_qubes-gui-vm.gschema.override
-	install -m 0644 -D appvm-scripts/etc/qubes-rpc/qubes.SetMonitorLayout \
+	install -d $(DESTDIR)/etc/qubes-rpc
+	ln -s ../../usr/bin/qubes-set-monitor-layout \
 		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
 	install -D window-icon-updater/icon-sender \
 		$(DESTDIR)/usr/lib/qubes/icon-sender
@@ -182,6 +183,8 @@
 		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
 	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
 		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
+	install -D appvm-scripts/usr/lib/qubes/qubes-gui-agent-pre.sh \
+		$(DESTDIR)/usr/lib/qubes/qubes-gui-agent-pre.sh
 ifeq ($(shell lsb_release -is), Debian)
 	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
 		$(DESTDIR)/etc/pam.d/qubes-gui-agent

=== pulse/Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 CC=gcc
 CFLAGS=-Wall -Wextra -Werror -O2
+LIBS=-lqubesdb
 VCHANLIBS=`pkg-config --libs vchan-$(BACKEND_VMM)`
 VCHANCFLAGS=`pkg-config --cflags vchan-$(BACKEND_VMM)`
 GLIBCFLAGS=`pkg-config --cflags glib-2.0` `pkg-config --cflags dbus-glib-1`
@@ -7,7 +8,7 @@
 all: module-vchan-sink.so
 module-vchan-sink.so: module-vchan-sink.o
 	$(CC) -shared -o module-vchan-sink.so module-vchan-sink.o \
-		$(VCHANLIBS)
+		$(VCHANLIBS) $(LIBS)
 module-vchan-sink.o: module-vchan-sink.c
 	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -I.
 clean:

=== debian/changelog ===
qubes-gui-agent (4.1.6-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sun, 01 Mar 2020 03:07:45 +0100

qubes-gui-agent (4.1.6-1) unstable; urgency=medium

  [ Neowutran ]
  * ARCHLINUX: xf86dgaproto doesn't exist anymore, and is no longer
    required. Removing it from the dependencies.

  [ Frédéric Pierret (fepitre) ]
  * travis: switch to dom0 Fedora 31

  [ Foppe ]
  * Update .travis.yml

  [ Zaoqi ]
  * archlinux: qubes-vm-gui: update PKGBUILD

  [ Marek Marczykowski-Górecki ]
  * Replace non-executable qubes.SetMonitorLayout file with a symlink
  * create /etc/qubes-rpc directory before placing a symlink there

  [ Frédéric Pierret (fepitre) ]
  * Allow GUI and AUDIO client to be ran before their corresonding
    servers
  * GUI/AUDIO xid: use 'wait' option of qubesdb-read

  [ Marek Marczykowski-Górecki ]
  * Require new enough qubesdb-read for -w option

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sun, 01 Mar 2020 03:07:45 +0100

## qubes-gui-agent 4.1.7

=== Makefile ===
--- 
+++ 
@@ -28,7 +28,8 @@
 USRLIBDIR ?= /usr/lib
 SYSLIBDIR ?= /lib
 DATADIR ?= /usr/share
-PA_VER ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
+PA_VER_FULL ?= $(shell pkg-config --modversion libpulse | cut -d "-" -f 1 || echo 0.0)
+PA_VER_MAJOR_MINOR ?= $(shell echo $(PA_VER_FULL) | cut -d "." -f 1,2)
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
@@ -62,7 +63,7 @@
 
 pulse/module-vchan-sink.so:
 	rm -f pulse/pulsecore
-	ln -s pulsecore-$(PA_VER) pulse/pulsecore
+	ln -s pulsecore-$(PA_VER_FULL) pulse/pulsecore
 	$(MAKE) -C pulse module-vchan-sink.so
 
 xf86-qubes-common/libxf86-qubes-common.so:
@@ -122,7 +123,7 @@
 	install -m 0644 -D pulse/qubes-default.pa \
 		$(DESTDIR)/etc/pulse/qubes-default.pa
 	install -D pulse/module-vchan-sink.so \
-		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER)/modules/module-vchan-sink.so
+		$(DESTDIR)$(LIBDIR)/pulse-$(PA_VER_MAJOR_MINOR)/modules/module-vchan-sink.so
 	install -m 0644 -D appvm-scripts/etc/tmpfiles.d/qubes-pulseaudio.conf \
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-pulseaudio.conf
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-pulseaudio.desktop \

=== debian/changelog ===
qubes-gui-agent (4.1.7-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Fri, 10 Apr 2020 05:57:53 +0200

qubes-gui-agent (4.1.7-1) unstable; urgency=medium

  [ Paweł Marczewski ]
  * pulseaudio: support reconnecting
  * pulseaudio 13.99.1
  * pulseaudio 13.99.1: add internal headers
  * Bump ICON_MAX_SIZE

  [ Yukikoo ]
  * Archlinux: more permissive with xorg-server update

  [ Paweł Marczewski ]
  * icon-sender: reconnect on failure
  * Send MSG_CURSOR
  * Check protocol version defined in qubes-gui-protocol.h

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Fri, 10 Apr 2020 05:57:53 +0200

## qubes-gui-agent 4.1.8

=== debian/changelog ===
qubes-gui-agent (4.1.8-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Thu, 21 May 2020 02:51:19 +0200

qubes-gui-agent (4.1.8-1) unstable; urgency=medium

  [ Marek Marczykowski-Górecki ]
  * pulse: fix pa_proplist_set[fs] usage

  [ Ivan Kardykov ]
  * fix typo

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 21 May 2020 02:51:19 +0200

=== debian/control ===
--- 
+++ 
@@ -13,6 +13,7 @@
     libx11-dev,
     libxcomposite-dev,
     libxdamage-dev,
+    libxfixes-dev,
     x11proto-xf86dga-dev,
     libxt-dev,
     libxen-dev,
@@ -35,9 +36,10 @@
     xinit,
     x11-xserver-utils,
     qubes-core-agent (>= 3.0.14),
-    qubesdb-vm,
+    qubesdb-vm (>= 4.1.4),
     libxdamage1,
     libxcomposite1,
+    libxfixes3,
     libxt6,
     libx11-6,
     python3,
@@ -92,6 +94,7 @@
 Package: pulseaudio-qubes
 Architecture: any
 Depends:
+    qubesdb-vm (>= 4.1.4),
     pulseaudio,
     libpulse0,
     ${shlibs:Depends},

## qubes-gui-agent 4.1.9

=== Makefile ===
--- 
+++ 
@@ -87,6 +87,8 @@
 	$(MAKE) -C xf86-qubes-common clean
 	(cd xf86-input-mfndev; if [ -e Makefile ] ; then \
 		$(MAKE) distclean; fi; ./bootstrap --clean || echo )
+	rm -rf debian/changelog.*
+	rm -rf pkgs
 
 
 install: install-rh-agent install-pulseaudio
@@ -102,10 +104,10 @@
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh \
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh
-
-install-xfce:
-	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50-xfce-desktop.sh \
-		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50-xfce-desktop.sh
+	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50guivm-windows-prefix.sh \
+		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50guivm-windows-prefix.sh
+	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh \
+		$(DESTDIR)/etc/X11/xinit/xinitrc.d/60xfce-desktop.sh
 
 install-debian: appvm install-common install-pulseaudio
 	install -d $(DESTDIR)/etc/X11/Xsession.d
@@ -163,8 +165,6 @@
 		$(DESTDIR)/$(USRLIBDIR)/tmpfiles.d/qubes-session.conf
 	install -m 0644 -D appvm-scripts/etc/securitylimits.d/90-qubes-gui.conf \
 		$(DESTDIR)/etc/security/limits.d/90-qubes-gui.conf
-	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/50-guivm-windows-prefix.sh \
-		$(DESTDIR)/etc/X11/xinit/xinitrc.d/50-guivm-windows-prefix.sh
 ifneq ($(shell lsb_release -is), Ubuntu)
 	install -m 0644 -D appvm-scripts/etc/xdg/Trolltech.conf \
 		$(DESTDIR)/etc/xdg/Trolltech.conf

=== gui-agent/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 CFLAGS += -I../include/ `pkg-config --cflags vchan-$(BACKEND_VMM)` -g -Wall -Wextra -Werror -pie -fPIC
 OBJS = vmside.o \
 	../gui-common/txrx-vchan.o ../gui-common/error.o ../common/list.o 
-LIBS = -lX11 -lXdamage -lXcomposite `pkg-config --libs vchan-$(BACKEND_VMM)` -lqubesdb
+LIBS = -lX11 -lXdamage -lXcomposite -lXfixes `pkg-config --libs vchan-$(BACKEND_VMM)` -lqubesdb
 
 
 all: qubes-gui

=== pulse/Makefile ===
--- 
+++ 
@@ -10,6 +10,6 @@
 	$(CC) -shared -o module-vchan-sink.so module-vchan-sink.o \
 		$(VCHANLIBS) $(LIBS)
 module-vchan-sink.o: module-vchan-sink.c
-	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -I.
+	$(CC) $(CFLAGS) -g -c $(VCHANCFLAGS) -fPIC module-vchan-sink.c  -DHAVE_CONFIG_H -DHAVE_QUBESDB_CLIENT_H -I.
 clean:
 	rm -f *.so *.o *~

=== debian/changelog ===
qubes-gui-agent (4.1.9-1+deb10u1) buster; urgency=medium

  * Build for buster

 -- Builder <user@localhost>  Mon, 29 Jun 2020 05:31:38 +0200

qubes-gui-agent (4.1.9-1) unstable; urgency=medium

  [ Dmitry Fedorov ]
  * conditionally use qubesdb dependency in vchan-sink module

  [ Olivier MEDOC ]
  * archlinux: set dependencies on xorg server ABI version instead of
    the server version itself

  [ Artur Puzio ]
  * Disable gui-agent on sys-gui-gpu

  [ deathgrippin ]
  * Condense conditional

  [ Rusty Bird ]
  * vmside: use XKillClient() if WM_DELETE_WINDOW is unsupported

  [ Frédéric Pierret (fepitre) ]
  * qubes-run-xephyr: debian has another path for shmoverride.so
  * Makefile: add clean of pkgs and debian changelog.*
  * debian: add xfce subpackage for VM
  * Check if shmoverride.so exists directly
  * debian: fix conflict with newer location of pulseaudio conf

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Mon, 29 Jun 2020 05:31:38 +0200

=== debian/control ===
--- 
+++ 
@@ -100,7 +100,15 @@
     ${shlibs:Depends},
     ${pulse:Depends},
     ${misc:Depends}
-Replaces: qubes-gui-agent (<< 4.0.0-1)
-Breaks: qubes-gui-agent (<< 4.0.0-1)
+Replaces: qubes-gui-agent (<< 4.1.9-1)
+Breaks: qubes-gui-agent (<< 4.1.9-1)
 Description: Audio support for Qubes VM
  Pulseaudio module to enable sound support in Qubes VM
+
+Package: qubes-gui-agent-xfce
+Architecture: any
+Depends:
+    ${shlibs:Depends},
+    ${misc:Depends}
+Description: XFCE desktop support for Qubes VM
+ XFCE desktop support for Qubes VM

## qubes-gui-agent 4.1.10

=== Makefile ===
--- 
+++ 
@@ -98,8 +98,6 @@
 		$(DESTDIR)/$(SYSLIBDIR)/systemd/system/qubes-gui-agent.service
 	install -m 0644 -D appvm-scripts/etc/sysconfig/desktop \
 		$(DESTDIR)/etc/sysconfig/desktop
-	install -m 0755 -D appvm-scripts/etc/X11/xinit/xinitrc.d/qubes-keymap.sh \
-		$(DESTDIR)/etc/X11/xinit/xinitrc.d/qubes-keymap.sh
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh \
 		$(DESTDIR)/etc/X11/xinit/xinitrc.d/20qt-x11-no-mitshm.sh
 	install -D appvm-scripts/etc/X11/xinit/xinitrc.d/20qt-gnome-desktop-session-id.sh \
@@ -111,8 +109,6 @@
 
 install-debian: appvm install-common install-pulseaudio
 	install -d $(DESTDIR)/etc/X11/Xsession.d
-	install -m 0755 appvm-scripts/etc/X11/xinit/xinitrc.d/qubes-keymap.sh \
-		$(DESTDIR)/etc/X11/Xsession.d/90qubes-keymap
 	install -m 0644 appvm-scripts/etc/X11/Xsession.d/* $(DESTDIR)/etc/X11/Xsession.d/
 	install -d $(DESTDIR)/etc/xdg
 	install -m 0644 appvm-scripts/etc/xdg-debian/* $(DESTDIR)/etc/xdg
@@ -180,12 +176,16 @@
 		$(DESTDIR)/etc/xdg/autostart/qubes-icon-sender.desktop
 	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-qrexec-fork-server.desktop \
 		$(DESTDIR)/etc/xdg/autostart/qubes-qrexec-fork-server.desktop
+	install -m 0644 -D appvm-scripts/etc/xdgautostart/qubes-keymap.desktop \
+		$(DESTDIR)/etc/xdg/autostart/qubes-keymap.desktop
 	install -D -m 0644 appvm-scripts/usr/lib/sysctl.d/30-qubes-gui-agent.conf \
 		$(DESTDIR)/usr/lib/sysctl.d/30-qubes-gui-agent.conf
 	install -D -m 0644 appvm-scripts/lib/udev/rules.d/70-master-of-seat.rules \
 		$(DESTDIR)/$(SYSLIBDIR)/udev/rules.d/70-master-of-seat.rules
 	install -D appvm-scripts/usr/lib/qubes/qubes-gui-agent-pre.sh \
 		$(DESTDIR)/usr/lib/qubes/qubes-gui-agent-pre.sh
+	install -D appvm-scripts/usr/lib/qubes/qubes-keymap.sh \
+		$(DESTDIR)/usr/lib/qubes/qubes-keymap.sh
 ifeq ($(shell lsb_release -is), Debian)
 	install -D -m 0644 appvm-scripts/etc/pam.d/qubes-gui-agent.debian \
 		$(DESTDIR)/etc/pam.d/qubes-gui-agent

=== debian/changelog ===
qubes-gui-agent (4.1.10-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 16 Jul 2020 06:12:58 +0200

qubes-gui-agent (4.1.10-1) unstable; urgency=medium

  [ Marta Marczykowska-Górecka ]
  * Modified keyboard layout handling

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 16 Jul 2020 06:12:58 +0200

## qubes-gui-agent 4.1.11

=== Makefile ===
--- 
+++ 
@@ -139,6 +139,8 @@
 		$(DESTDIR)/usr/bin/qubes-run-xorg
 	install -D appvm-scripts/usrbin/qubes-run-xephyr \
 		$(DESTDIR)/usr/bin/qubes-run-xephyr
+	install -D appvm-scripts/usrbin/qubes-start-xephyr \
+		$(DESTDIR)/usr/bin/qubes-start-xephyr
 	install -D appvm-scripts/usrbin/qubes-change-keyboard-layout \
 		$(DESTDIR)/usr/bin/qubes-change-keyboard-layout
 	install -D appvm-scripts/usrbin/qubes-set-monitor-layout \
@@ -170,6 +172,8 @@
 	install -d $(DESTDIR)/etc/qubes-rpc
 	ln -s ../../usr/bin/qubes-set-monitor-layout \
 		$(DESTDIR)/etc/qubes-rpc/qubes.SetMonitorLayout
+	ln -s ../../usr/bin/qubes-start-xephyr \
+		$(DESTDIR)/etc/qubes-rpc/qubes.GuiVMSession
 	install -D window-icon-updater/icon-sender \
 		$(DESTDIR)/usr/lib/qubes/icon-sender
 	install -m 0644 -D window-icon-updater/qubes-icon-sender.desktop \

=== debian/changelog ===
qubes-gui-agent (4.1.11-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 06 Aug 2020 05:34:20 +0200

qubes-gui-agent (4.1.11-1) unstable; urgency=medium

  [ Paweł Marczewski ]
  * Extract Xephyr to a separate script

  [ Marek Marczykowski-Górecki ]
  * guivm: clean qrexec-service related environment in GUI session

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 06 Aug 2020 05:34:20 +0200

## qubes-gui-agent 4.1.12

=== debian/changelog ===
qubes-gui-agent (4.1.12-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Sat, 10 Oct 2020 04:20:24 +0200

qubes-gui-agent (4.1.12-1) unstable; urgency=medium

  [ Matt McCutchen ]
  * module-vchan-sink: link up the card properly

  [ Frédéric Pierret (fepitre) ]
  * pulseaudio: allow bluetooth devices like headphones

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Sat, 10 Oct 2020 04:20:24 +0200

## qubes-gui-agent 4.1.13

=== debian/changelog ===
qubes-gui-agent (4.1.13-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 29 Oct 2020 22:06:24 +0100

qubes-gui-agent (4.1.13-1) unstable; urgency=medium

  [ unman ]
  * pulseaudio 13.99.2: add internal headers
  * pulseaudio 13.99.2

  [ Frédéric Pierret (fepitre) ]
  * Fix archlinux packaging

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 29 Oct 2020 22:06:24 +0100

## qubes-gui-agent 4.1.14

=== Makefile ===
--- 
+++ 
@@ -19,11 +19,7 @@
 #
 #
 
-RPMS_DIR=rpm/
 VERSION := $(shell cat version)
-
-DIST_DOM0 ?= fc13
-
 LIBDIR ?= /usr/lib64
 USRLIBDIR ?= /usr/lib
 SYSLIBDIR ?= /lib
@@ -33,15 +29,8 @@
 
 help:
 	@echo "Qubes GUI main Makefile:" ;\
-	    echo "make rpms                 <--- make all rpms and sign them";\
-	    echo "make rpms-dom0            <--- create binary rpms for dom0"; \
-	    echo "make rpms-vm              <--- create binary rpms for appvm"; \
 	    echo; \
 	    echo "make clean                <--- clean all the binary files";\
-	    echo "make update-repo-current  <-- copy newly generated rpms to qubes yum repo";\
-	    echo "make update-repo-current-testing <-- same, but for -current-testing repo";\
-	    echo "make update-repo-unstable <-- same, but to -testing repo";\
-	    echo "make update-repo-installer -- copy dom0 rpms to installer repo"
 	    @exit 0;
 
 appvm: gui-agent/qubes-gui gui-common/qubes-gui-runuser \
@@ -50,16 +39,18 @@
 	xf86-qubes-common/libxf86-qubes-common.so
 
 gui-agent/qubes-gui:
-	(cd gui-agent; $(MAKE))
+	$(MAKE) -C gui-agent
 
 gui-common/qubes-gui-runuser:
-	(cd gui-common; $(MAKE))
+	$(MAKE) -C gui-common
 
 xf86-input-mfndev/src/.libs/qubes_drv.so: xf86-qubes-common/libxf86-qubes-common.so
-	(cd xf86-input-mfndev && ./autogen.sh && ./configure && make)
+	(cd xf86-input-mfndev && ./autogen.sh && ./configure)
+	$(MAKE) -C xf86-input-mfndev
 
 xf86-video-dummy/src/.libs/dummyqbs_drv.so: xf86-qubes-common/libxf86-qubes-common.so
-	(cd xf86-video-dummy && ./autogen.sh && make)
+	(cd xf86-video-dummy && ./autogen.sh)
+	$(MAKE) -C xf86-video-dummy
 
 pulse/module-vchan-sink.so:
 	rm -f pulse/pulsecore
@@ -68,13 +59,6 @@
 
 xf86-qubes-common/libxf86-qubes-common.so:
 	$(MAKE) -C xf86-qubes-common libxf86-qubes-common.so
-
-rpms: rpms-dom0 rpms-vm
-	rpm --addsign rpm/x86_64/*$(VERSION)*.rpm
-	(if [ -d rpm/i686 ] ; then rpm --addsign rpm/i686/*$(VERSION)*.rpm; fi)
-
-rpms-vm:
-	rpmbuild --define "_rpmdir rpm/" -bb rpm_spec/gui-vm.spec
 
 tar:
 	git archive --format=tar --prefix=qubes-gui/ HEAD -o qubes-gui.tar

=== debian/changelog ===
qubes-gui-agent (4.1.14-1+deb11u1) bullseye; urgency=medium

  * Build for bullseye

 -- Builder <user@localhost>  Thu, 03 Dec 2020 15:17:10 +0100

qubes-gui-agent (4.1.14-1) unstable; urgency=medium

  [ icequbes1 ]
  * Link pulsecore 13.99.3 headers to 13.99.2

  [ Marek Marczykowski-Górecki ]
  * xf86-video-dummy: improve error message on xengntshr_open fail

  [ Frédéric Pierret (fepitre) ]
  * Add .gitlab-ci.yml

  [ Marek Marczykowski-Górecki ]
  * gitlab-ci: exclude qubes-gui-agent when installing in dom0

  [ Demi Marie Obenour ]
  * Fix Unicode handling in Qubes clipboard
  * Make variables static and add extern declaration

  [ Frédéric Pierret (fepitre) ]
  * Set default BACKEND_VMM value to xen
  * Use pkg-config to get BACKEND_VMM

  [ Demi Marie Obenour ]
  * Fix indentation and segfault

  [ icequbes1 ]
  * [ubuntu] Perform quilt refresh for ubuntu-only patch

  [ Frédéric Pierret (fepitre) ]
  * Add script for getting latest pulsecore headers
  * Add pulseaudio-14.0 headers
  * Few improvements from Marek's suggestions
  * Allow to override defined CFLAGS
  * Refactor main Makefile

 -- Marek Marczykowski-Górecki <marmarek@invisiblethingslab.com>  Thu, 03 Dec 2020 15:17:10 +0100
